"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var redux_form_1 = require("redux-form");
var lodash_1 = require("lodash");
var validate_general_info_form_1 = __importDefault(require("./validate_general_info_form"));
var index_1 = __importDefault(require("@material-ui/core/Button/index"));
var Typography_1 = __importDefault(require("@material-ui/core/Typography"));
var forms_1 = require("../../../../ui/forms");
var actions_1 = require("../../actions");
var GeneraInfoConfigurationAppForm = react_1.memo(function (props) {
    var dispatch = react_redux_1.useDispatch();
    var pristine = props.pristine, submitting = props.submitting, reset = props.reset, handleSubmit = props.handleSubmit, initialValues = props.initialValues, _a = props.social, social = _a === void 0 ? {} : _a;
    var logo_medium = initialValues.logo_medium, logo_small = initialValues.logo_small, icon_medium = initialValues.icon_medium, icon_small = initialValues.icon_small, favicon = initialValues.favicon, favicon_medium = initialValues.favicon_medium, favicon_small = initialValues.favicon_small;
    var _b = social.show_facebook, show_facebook = _b === void 0 ? false : _b, _c = social.show_twitter, show_twitter = _c === void 0 ? false : _c, _d = social.show_instagram, show_instagram = _d === void 0 ? false : _d, _e = social.show_linkedin, show_linkedin = _e === void 0 ? false : _e, _f = social.show_youtube, show_youtube = _f === void 0 ? false : _f, _g = social.show_whatsaap, show_whatsaap = _g === void 0 ? false : _g;
    var onSubmit = function (v) {
        return dispatch(actions_1.updateGeneralInfoConfigurationApp(initialValues.id, v));
    };
    var submitObject = function (item) {
        var datos_formulario = lodash_1.omit(item, 'logo');
        // @ts-ignore
        datos_formulario = lodash_1.omit(datos_formulario, 'favicon');
        var datos_a_subir = new FormData();
        lodash_1.mapKeys(datos_formulario, function (item, key) {
            // @ts-ignore
            datos_a_subir.append(key, item);
        });
        if (item.logo) {
            if (typeof item.logo !== 'string') {
                // @ts-ignore
                datos_a_subir.append('logo', item.logo[0]);
            }
        }
        if (item.favicon) {
            if (typeof item.favicon !== 'string') {
                // @ts-ignore
                datos_a_subir.append('favicon', item.favicon[0]);
            }
        }
        return datos_a_subir;
    };
    return (react_1.default.createElement("form", { onSubmit: handleSubmit(function (v) {
            return onSubmit(submitObject(v));
        }) },
        react_1.default.createElement("div", { className: "row" },
            react_1.default.createElement(forms_1.MyTextFieldSimple, { className: 'col-12 col-md-4 col-lg-3 col-xl-2', label: 'Nombre App', name: 'application_name' }),
            react_1.default.createElement("div", { className: "col-12" },
                react_1.default.createElement("div", { className: "row" },
                    react_1.default.createElement(forms_1.MyTextFieldSimple, { rows: 4, multiline: true, className: 'col-12 col-md-4 col-lg-3 col-xl-2', label: 'Direcci\u00F3n', name: 'address' }),
                    react_1.default.createElement(forms_1.MyTextFieldSimple, { rows: 4, multiline: true, className: 'col-12 col-md-4 col-lg-3 col-xl-2', label: 'Horario de Atenci\u00F3n', name: 'attention_schedule' }),
                    react_1.default.createElement(forms_1.MyTextFieldSimple, { rows: 4, multiline: true, className: 'col-12 col-md-6 col-xl-4', label: 'Email de Contacto', name: 'contact_emails' }))),
            react_1.default.createElement("div", { className: "col-12" },
                react_1.default.createElement(Typography_1.default, { variant: "h5", color: "primary", noWrap: true }, "Social Networks"),
                react_1.default.createElement("div", { className: "row" },
                    show_whatsaap && react_1.default.createElement(forms_1.MyTextFieldSimple, { className: 'col-12 col-md-6 col-lg-4', label: 'Contacto Whatsaap', name: 'whatsaap' }),
                    show_instagram && react_1.default.createElement(forms_1.MyTextFieldSimple, { className: 'col-12 col-md-6 col-lg-4', label: 'Instagram', name: 'instagram' }),
                    show_linkedin && react_1.default.createElement(forms_1.MyTextFieldSimple, { className: 'col-12 col-md-6 col-lg-4', label: 'Linked In', name: 'linkedin' }),
                    show_youtube && react_1.default.createElement(forms_1.MyTextFieldSimple, { className: 'col-12 col-md-6 col-lg-4', label: 'Youtube', name: 'youtube' }),
                    show_twitter && react_1.default.createElement(forms_1.MyTextFieldSimple, { className: 'col-12 col-md-6 col-lg-4', label: 'Twitter', name: 'twitter' }),
                    show_facebook && react_1.default.createElement(forms_1.MyTextFieldSimple, { className: 'col-12 col-md-6 col-lg-4', label: 'Facebook', name: 'facebook' }))),
            react_1.default.createElement("div", { className: 'col-12' },
                react_1.default.createElement(Typography_1.default, { variant: "h5", color: "primary", noWrap: true }, "Imagenes"),
                react_1.default.createElement("div", { className: "row" },
                    react_1.default.createElement("div", { className: "col-12" },
                        react_1.default.createElement(Typography_1.default, { variant: "h6", color: "secondary", noWrap: true }, "Logo"),
                        react_1.default.createElement("div", { className: "row" },
                            react_1.default.createElement("div", { className: "col-12 col-sm-12 col-lg-4 text-center" },
                                react_1.default.createElement("div", null,
                                    react_1.default.createElement("img", { src: logo_medium })),
                                react_1.default.createElement("div", null, "300x300")),
                            react_1.default.createElement("div", { className: "col-12 col-sm-6 col-lg-3 text-center" },
                                react_1.default.createElement("div", null,
                                    react_1.default.createElement("img", { src: logo_small })),
                                react_1.default.createElement("div", null, "256x256")),
                            react_1.default.createElement("div", { className: "col-12 col-sm-4 col-lg-2 text-center" },
                                react_1.default.createElement("div", null,
                                    react_1.default.createElement("img", { src: icon_medium })),
                                react_1.default.createElement("div", null, "48x48")),
                            react_1.default.createElement("div", { className: "col-12 col-sm-2 col-lg-1 text-center" },
                                react_1.default.createElement("div", null,
                                    react_1.default.createElement("img", { src: icon_small })),
                                react_1.default.createElement("div", null, "32x32"))),
                        react_1.default.createElement(forms_1.MyFileFieldInput, { name: "logo", accept: "image/png, image/jpeg" })),
                    react_1.default.createElement("div", { className: "col-12" },
                        react_1.default.createElement(Typography_1.default, { variant: "h6", color: "secondary", noWrap: true }, "Icono"),
                        react_1.default.createElement("div", { className: "row" },
                            react_1.default.createElement("div", { className: "col-12 col-sm-12 col-lg-4 text-center" },
                                react_1.default.createElement("div", null,
                                    react_1.default.createElement("img", { src: favicon })),
                                react_1.default.createElement("div", null, "48x48")),
                            react_1.default.createElement("div", { className: "col-12 col-sm-6 col-lg-3 text-center" },
                                react_1.default.createElement("div", null,
                                    react_1.default.createElement("img", { src: favicon_medium })),
                                react_1.default.createElement("div", null, "32x32")),
                            react_1.default.createElement("div", { className: "col-12 col-sm-4 col-lg-2 text-center" },
                                react_1.default.createElement("div", null,
                                    react_1.default.createElement("img", { src: favicon_small })),
                                react_1.default.createElement("div", null, "16x16"))),
                        react_1.default.createElement(forms_1.MyFileFieldInput, { name: "favicon", accept: "image/png, image/jpeg" })))),
            react_1.default.createElement("div", { className: "col-12" },
                react_1.default.createElement(index_1.default, { color: "primary", type: 'submit', variant: "contained", className: 'ml-3', disabled: submitting || pristine }, "Guardar"),
                react_1.default.createElement(index_1.default, { color: "secondary", variant: "contained", className: 'ml-3', disabled: submitting || pristine, onClick: reset }, "Limpiar")))));
});
exports.GeneraInfoConfigurationAppForm = GeneraInfoConfigurationAppForm;
// @ts-ignore
exports.GeneraInfoConfigurationAppForm = GeneraInfoConfigurationAppForm = redux_form_1.reduxForm({
    form: "generalInfoConfigurationAppForm",
    validate: validate_general_info_form_1.default,
    enableReinitialize: true
    // @ts-ignore
})(GeneraInfoConfigurationAppForm);
