"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("./types");
var functions_1 = require("../../../system/functions");
var current_url_api = 'permissions';
// export const fetchHasPermissionsxList = (permission_list = [], options_action: IOptions = {}) => {
//     let permissions_list_parameter = '';
//     permission_list.map(lista => {
//         mapKeys(lista, (v) => {
//             permissions_list_parameter = permission_list.concat(`${v},`);
//         });
//     });
//     return function (dispatch: any) {
//         const SUB_URL = '/has_permissions';
//         const FULL_URL = `${current_url_api}${SUB_URL}/?permissions_list_parameter=${permissions_list_parameter}`;
//         const dispatches = (response = {}) => {
//             dispatch({type: TYPES.mis_permisos, payload: {...response, ...options_action}})
//         };
//         const {must_clear_collection = true} = options_action;
//         const options = {
//             dispatches,
//             ...options_action,
//             dispatch_method: dispatch,
//             clear_action_type: must_clear_collection ? TYPES.clear : null
//         };
//         return fetchListGetURLParameters(FULL_URL, options);
//     }
// };
function fetchMyPermissions(options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var SUB_URL = '/my_permissions';
        var FULL_URL = "" + current_url_api + SUB_URL;
        var _a = options_action.must_clear_collection, must_clear_collection = _a === void 0 ? true : _a;
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch, clear_action_type: must_clear_collection ? types_1.PERMISSION_TYPES.clear : null });
        return functions_1.fetchListGet(FULL_URL, options);
    };
}
exports.fetchMyPermissions = fetchMyPermissions;
function fetchPermissionsActive(options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var SUB_URL = '/active';
        var FULL_URL = "" + current_url_api + SUB_URL;
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.PERMISSION_TYPES.fetch_all, payload: __assign(__assign({}, response), options_action) });
        };
        var _a = options_action.must_clear_collection, must_clear_collection = _a === void 0 ? true : _a;
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch, clear_action_type: must_clear_collection ? types_1.PERMISSION_TYPES.clear : null });
        return functions_1.fetchListGet(FULL_URL, options);
    };
}
exports.fetchPermissionsActive = fetchPermissionsActive;
function fetchPermissionsByGroup(group_id, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var SUB_URL = "/by_group/?group_id=" + group_id;
        var FULL_URL = "" + current_url_api + SUB_URL;
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.PERMISSION_TYPES.fetch_all, payload: __assign(__assign({}, response), options_action) });
        };
        var _a = options_action.must_clear_collection, must_clear_collection = _a === void 0 ? true : _a;
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch, clear_action_type: must_clear_collection ? types_1.PERMISSION_TYPES.clear : null });
        return functions_1.fetchListGetURLParameters(FULL_URL, options);
    };
}
exports.fetchPermissionsByGroup = fetchPermissionsByGroup;
function fetchPermissionsxUsuario(id, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var SUB_URL = "/permiso_x_usuario/?user_id=" + id;
        var FULL_URL = "" + current_url_api + SUB_URL;
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.PERMISSION_TYPES.fetch_all, payload: __assign(__assign({}, response), options_action) });
        };
        var _a = options_action.must_clear_collection, must_clear_collection = _a === void 0 ? true : _a;
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch, clear_action_type: must_clear_collection ? types_1.PERMISSION_TYPES.clear : null });
        return functions_1.fetchListGetURLParameters(FULL_URL, options);
    };
}
exports.fetchPermissionsxUsuario = fetchPermissionsxUsuario;
exports.fetchPermissions = function (options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.PERMISSION_TYPES.fetch_all, payload: __assign(__assign({}, response), options_action) });
        };
        var _a = options_action.must_clear_collection, must_clear_collection = _a === void 0 ? true : _a;
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch, clear_action_type: must_clear_collection ? types_1.PERMISSION_TYPES.clear : null });
        return functions_1.fetchListGet(current_url_api, options);
    };
};
exports.updatePermission = function (id, values, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.PERMISSION_TYPES.update, payload: __assign(__assign({}, response), options_action) });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.updateObject(current_url_api, id, values, options);
    };
};
exports.fetchPermission = function (id, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.PERMISSION_TYPES.fetch, payload: __assign(__assign({}, response), options_action) });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.fetchObject(current_url_api, id, options);
    };
};
exports.clearPermissions = function (options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        dispatch({ type: types_1.PERMISSION_TYPES.clear, payload: options_action });
    };
};
