"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("./types");
var functions_1 = require("../../../system/functions");
var current_url_api = 'countries_cities';
exports.createCity = function (values, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            dispatch({ type: types_1.CITY_TYPES.create, payload: __assign(__assign({}, response), options_action) });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.createObject(current_url_api, values, options);
    };
};
exports.deleteCity = function (id, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            dispatch({ type: types_1.CITY_TYPES.delete, payload: id });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.deleteObject(current_url_api, id, options);
    };
};
exports.fetchCities = function (options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            dispatch({ type: types_1.CITY_TYPES.fetch_all, payload: __assign(__assign({}, response), options_action) });
        };
        var _a = options_action.must_clear_collection, must_clear_collection = _a === void 0 ? true : _a;
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch, clear_action_type: must_clear_collection ? types_1.CITY_TYPES.clear : null });
        return functions_1.fetchListGet(current_url_api, options);
    };
};
exports.fetchCitiesByName = function (name, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var _a = options_action.must_clear_collection, must_clear_collection = _a === void 0 ? true : _a;
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch, clear_action_type: must_clear_collection ? types_1.CITY_TYPES.clear : null });
        return functions_1.fetchListGetURLParameters(current_url_api + "/by_name/?name=" + name, options);
    };
};
exports.fetchCity = function (id, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            dispatch({ type: types_1.CITY_TYPES.fetch, payload: __assign(__assign({}, response), options_action) });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.fetchObject(current_url_api, id, options);
    };
};
exports.clearCities = function (options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        dispatch({ type: types_1.CITY_TYPES.clear, payload: options_action });
    };
};
exports.updateCity = function (id, values, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            dispatch({ type: types_1.CITY_TYPES.update, payload: __assign(__assign({}, response), options_action) });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.updateObject(current_url_api, id, values, options);
    };
};
