"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("./types");
var functions_1 = require("../../../system/functions");
var current_url_api = 'countries';
exports.getTokenCoutriesREST = function (options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        return functions_1.fetchApiRestGet("https://www.universal-tutorial.com/api/getaccesstoken", options_action, {
            "Accept": "application/json",
            "api-token": "Yqht7rj50A4axCqtNTCwRc9eKbn-_jpSvFRZa4iL00U9nYnSZboxuL6CkqyH2-xzZRg",
            "user-email": "fabio.garcia.sanchez@gmail.com"
        });
    };
};
exports.fetchCoutriesREST = function (token, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var _a = options_action.must_clear_collection, must_clear_collection = _a === void 0 ? true : _a;
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.COUNTRY_TYPES.fetch_all, payload: __assign(__assign({}, response), options_action) });
        };
        var options = __assign(__assign({}, options_action), { dispatches: dispatches, dispatch_method: dispatch, clear_action_type: must_clear_collection ? types_1.COUNTRY_TYPES.clear : null });
        return functions_1.fetchApiRestGet("https://www.universal-tutorial.com/api/countries", options, {
            "Authorization": "Bearer " + token,
            "Accept": "application/json"
        });
    };
};
exports.createCountry = function (values, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.COUNTRY_TYPES.create, payload: __assign(__assign({}, response), options_action) });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.createObject(current_url_api, values, options);
    };
};
exports.createMultipleStatesCountry = function (id, states, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var params = new URLSearchParams();
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.COUNTRY_TYPES.update, payload: __assign(__assign({}, response), options_action) });
        };
        params.append('states', JSON.stringify(states));
        var options = __assign(__assign({}, options_action), { dispatches: dispatches, dispatch_method: dispatch });
        return functions_1.callApiMethodPostParameters(current_url_api, id, 'create_multiple_states_by_country', params, options);
    };
};
exports.createMultipleCountries = function (countries, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var params = new URLSearchParams();
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.COUNTRY_TYPES.fetch_all, payload: __assign(__assign({}, response), options_action) });
        };
        params.append('countries', JSON.stringify(countries));
        var options = __assign(__assign({}, options_action), { dispatches: dispatches, dispatch_method: dispatch });
        return functions_1.callApiMethodPostParameters(current_url_api, null, 'create_multiple_countries', params, options);
    };
};
exports.createMultipleStates = function (states, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var params = new URLSearchParams();
        params.append('states', JSON.stringify(states));
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.callApiMethodPostParameters(current_url_api, null, 'create_multiple_states', params, options);
    };
};
exports.createMultipleCities = function (cities, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var params = new URLSearchParams();
        params.append('cities', JSON.stringify(cities));
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.callApiMethodPostParameters(current_url_api, null, 'create_multiple_cities', params, options);
    };
};
exports.deleteCountry = function (id, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.COUNTRY_TYPES.delete, payload: id });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.deleteObject(current_url_api, id, options);
    };
};
exports.fetchCountries = function (options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.COUNTRY_TYPES.fetch_all, payload: __assign(__assign({}, response), options_action) });
        };
        var _a = options_action.must_clear_collection, must_clear_collection = _a === void 0 ? true : _a;
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch, clear_action_type: must_clear_collection ? types_1.COUNTRY_TYPES.clear : null });
        return functions_1.fetchListGet(current_url_api, options);
    };
};
exports.fetchCountry = function (id, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.COUNTRY_TYPES.fetch, payload: __assign(__assign({}, response), options_action) });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.fetchObject(current_url_api, id, options);
    };
};
exports.clearCountries = function (options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        dispatch({ type: types_1.COUNTRY_TYPES.clear, payload: options_action });
    };
};
exports.updateCountry = function (id, values, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            if (response === void 0) { response = {}; }
            dispatch({ type: types_1.COUNTRY_TYPES.update, payload: __assign(__assign({}, response), options_action) });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.updateObject(current_url_api, id, values, options);
    };
};
