"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var lodash_1 = require("lodash");
var layouts_1 = require("../../../../ui/layouts");
var actions_1 = require("../../actions");
var permissions_1 = require("../../permissions");
var hooks_1 = require("../../../../hooks");
var CreateFromFileDialog_1 = require("../CreateFromFileDialog");
var CityCreateFromFileTable_1 = require("./CityCreateFromFileTable");
var CityCRUDTable_1 = require("./CityCRUDTable");
var CityCRUDForm_1 = require("./CityCRUDForm");
var CRUD = layouts_1.HOCCrud(CityCRUDForm_1.CountryCityCRUDForm, CityCRUDTable_1.CountryCRUDTable);
var CityCRUD = react_1.memo(function (props) {
    var dispatch = react_redux_1.useDispatch();
    var state = props.state, loadData = props.loadData;
    var permissions = hooks_1.useHasPermissions(permissions_1.CITIES_PERMISSIONS);
    var _a = react_1.useState(null), cities_file = _a[0], setCitiesFile = _a[1];
    var inputFileChanged = function (e) {
        var reader = new FileReader();
        var file = e.target.files[0];
        reader.onload = function (n) {
            // @ts-ignore
            setCitiesFile(JSON.parse(n.target.result));
        };
        reader.readAsText(file);
    };
    var method_pool = {
        fetchObjectMethod: function (id, options) { return dispatch(actions_1.fetchCity(id, options)); },
        deleteObjectMethod: function (id, options) { return dispatch(actions_1.deleteCity(id, options)); },
        createObjectMethod: function (item, options) { return dispatch(actions_1.createCity(__assign(__assign({}, item), { state_id: state.id }), options)); },
        updateObjectMethod: function (id, item, options) { return dispatch(actions_1.updateCity(id, item, options)); }
    };
    var onCreateFromFile = function (cities) {
        var cities_to_create = lodash_1.map(cities, function (s) { return (__assign(__assign({}, s), { name: s.name.replace('Department', '').trim() })); });
        dispatch(actions_1.createMultipleCitiesState(state.id, cities_to_create, { callback: function () { return setCitiesFile(null); } }));
    };
    var state_cities = state.cities;
    var current_cities_ids = state_cities.map(function (c) { return "" + c.id; });
    return react_1.default.createElement(react_1.Fragment, null,
        cities_file === null && react_1.default.createElement("input", { type: 'file', onChange: inputFileChanged }),
        permissions.add && react_1.default.createElement(CreateFromFileDialog_1.CreateFromFileDialog, { title: 'Creaci\u00F3n masiva de ciudades', modal_open: cities_file !== null, onCancel: function () { return setCitiesFile(null); } },
            react_1.default.createElement(CityCreateFromFileTable_1.CityCreateFromFileTable, { list: lodash_1.pickBy(lodash_1.pickBy(cities_file, function (s) { return s.state_id === state.id; }), function (c) { return !current_cities_ids.includes(c.id); }), onCreateFromFile: onCreateFromFile })),
        react_1.default.createElement(CRUD, { posDeleteMethod: loadData, posSummitMethod: loadData, method_pool: method_pool, list: lodash_1.mapKeys(state_cities, 'id'), permissions: permissions, plural_name: 'Ciudades', singular_name: 'Ciudad', loadData: loadData }));
});
exports.CityCRUD = CityCRUD;
