"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var hooks_1 = require("../../../../hooks");
var layouts_1 = require("../../../../ui/layouts");
var permissions_1 = require("../../permissions");
var lodash_1 = require("lodash");
var actions_1 = require("../../actions");
var StateCreateFromFileTable_1 = require("./StateCreateFromFileTable");
var CreateFromFileDialog_1 = require("../CreateFromFileDialog");
var StateCRUDTable_1 = require("./StateCRUDTable");
var StateCRUDForm_1 = require("./StateCRUDForm");
var CRUD = layouts_1.HOCCrud(StateCRUDForm_1.CountryStateCRUDForm, StateCRUDTable_1.CountryStateCRUDTable);
var StateCRUD = react_1.memo(function (props) {
    var dispatch = react_redux_1.useDispatch();
    var view_link = props.view_link, country = props.country, loadData = props.loadData;
    var permissions = hooks_1.useHasPermissions(permissions_1.STATES_PERMISSIONS);
    var _a = react_1.useState(null), states_file = _a[0], setStatesFile = _a[1];
    var inputFileChanged = function (e) {
        var reader = new FileReader();
        var file = e.target.files[0];
        reader.onload = function (n) {
            // @ts-ignore
            setStatesFile(JSON.parse(n.target.result));
        };
        reader.readAsText(file);
    };
    var onCreateFromFile = function (states) {
        var states_to_create = lodash_1.map(states, function (s) { return (__assign(__assign({}, s), { name: s.name.replace('Department', '').trim() })); });
        dispatch(actions_1.createMultipleStatesCountry(country.id, states_to_create, { callback: function () { return setStatesFile(null); } }));
    };
    var method_pool = {
        fetchObjectMethod: function (id, options) { return dispatch(actions_1.fetchState(id, options)); },
        deleteObjectMethod: function (id, options) { return dispatch(actions_1.deleteState(id, options)); },
        createObjectMethod: function (item, options) { return dispatch(actions_1.createState(__assign(__assign({}, item), { country: country.id }), options)); },
        updateObjectMethod: function (id, item, options) { return dispatch(actions_1.updateState(id, item, options)); }
    };
    var states = country.states;
    var current_states_ids = states.map(function (c) { return c.id; });
    return react_1.default.createElement(react_1.Fragment, null,
        states_file === null && react_1.default.createElement("input", { type: 'file', onChange: inputFileChanged }),
        permissions.add && react_1.default.createElement(CreateFromFileDialog_1.CreateFromFileDialog, { title: 'Departamentos/Estados creaci\u00F3n m\u00E1siva', modal_open: states_file !== null, onCancel: function () { return setStatesFile(null); } },
            react_1.default.createElement(StateCreateFromFileTable_1.StateCreateFromFileTable, { list: lodash_1.pickBy(lodash_1.pickBy(states_file, function (s) { return s.country_id === country.id; }), function (c) { return !current_states_ids.includes(c.id); }), onCreateFromFile: onCreateFromFile })),
        react_1.default.createElement(CRUD, { posDeleteMethod: loadData, posSummitMethod: loadData, method_pool: method_pool, list: lodash_1.mapKeys(states, 'id'), permissions: __assign(__assign({}, permissions), { add: false }), plural_name: 'Departamentos/Estados', singular_name: 'Departamento/Estado', view_link: view_link, loadData: loadData }));
});
exports.StateCRUD = StateCRUD;
