"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("./types");
var functions_1 = require("../../../system/functions");
var current_url_api = 'users';
exports.changePasswordUser = function (id, password_old, password, password_2, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var params = new URLSearchParams();
        params.append('password_old', password_old);
        params.append('password', password);
        params.append('password_2', password_2);
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.callApiMethodPostParameters(current_url_api, id, 'change_password', params, options);
    };
};
exports.changePasswordOtherUser = function (id, password, password_2, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var params = new URLSearchParams();
        params.append('password', password);
        params.append('password_2', password_2);
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.callApiMethodPostParameters(current_url_api, id, 'change_password_other', params, options);
    };
};
exports.changeSecurityPinUser = function (id, password, pin, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var params = new URLSearchParams();
        params.append('password', password);
        params.append('pin', pin);
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.callApiMethodPostParameters(current_url_api, id, 'change_security_pin', params, options);
    };
};
exports.changeSecurityPinOtherUser = function (id, pin, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var params = new URLSearchParams();
        params.append('pin', pin);
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.callApiMethodPostParameters(current_url_api, id, 'change_security_pin_other', params, options);
    };
};
exports.validateAccountUser = function (id, activation_key, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var params = new URLSearchParams();
        params.append('activation_key', activation_key);
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.callApiMethodPostParameters(current_url_api, id, 'validate_account', params, options);
    };
};
exports.setRestorePasswordUser = function (id, activation_key, password, password_2, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var params = new URLSearchParams();
        params.append('activation_key', activation_key);
        params.append('password_2', password_2);
        params.append('password', password);
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.callApiMethodPostParameters(current_url_api, id, 'set_restored_password', params, options);
    };
};
exports.askRestorePasswordAccountUser = function (username, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var params = new URLSearchParams();
        params.append('username', username);
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.callApiMethodPostParameters(current_url_api, null, 'ask_restore_password', params, options);
    };
};
exports.generateSecurityQrUser = function (id, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.callApiMethodPost(current_url_api, id, 'generate_security_qr', options);
    };
};
exports.showSecurityQrUser = function (id, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.callApiMethodPost(current_url_api, id, 'generate_security_qr', options);
    };
};
function fetchUsersxPermission(permiso_nombre, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var FULL_URL = current_url_api + "/listar_x_permiso/?permiso_nombre=" + permiso_nombre;
        var dispatches = function (response) {
            dispatch({ type: types_1.USERS_TYPES.fetch_all, payload: __assign(__assign({}, response), options_action) });
        };
        var _a = options_action.must_clear_collection, must_clear_collection = _a === void 0 ? true : _a;
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch, clear_action_type: must_clear_collection ? types_1.USERS_TYPES.clear : null });
        return functions_1.fetchListGetURLParameters(FULL_URL, options);
    };
}
exports.fetchUsersxPermission = fetchUsersxPermission;
exports.addPermissionUser = function (id, permission_id, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var params = new URLSearchParams();
        params.append('permission_id', permission_id);
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.callApiMethodPostParameters(current_url_api, id, 'add_permission', params, options);
    };
};
exports.addGroupUser = function (id, id_group, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var params = new URLSearchParams();
        params.append('id_group', id_group);
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.callApiMethodPostParameters(current_url_api, id, 'add_group', params, options);
    };
};
exports.createUser = function (values, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            dispatch({ type: types_1.USERS_TYPES.create, payload: response });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.createObject(current_url_api, values, options);
    };
};
exports.deleteUser = function (id, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function () {
            dispatch({ type: types_1.USERS_TYPES.delete, payload: id });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.deleteObject(current_url_api, id, options);
    };
};
exports.fetchUsers = function (options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            dispatch({ type: types_1.USERS_TYPES.fetch_all, payload: __assign(__assign({}, response), options_action) });
        };
        var _a = options_action.must_clear_collection, must_clear_collection = _a === void 0 ? true : _a;
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch, clear_action_type: must_clear_collection ? types_1.USERS_TYPES.clear : null });
        return functions_1.fetchListGet(current_url_api, options);
    };
};
exports.fetchUser = function (id, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            dispatch({ type: types_1.USERS_TYPES.fetch, payload: response });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.fetchObject(current_url_api, id, options);
    };
};
exports.clearUsers = function () {
    return function (dispatch) {
        dispatch({ type: types_1.USERS_TYPES.clear });
    };
};
exports.updateUser = function (id, values, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var dispatches = function (response) {
            dispatch({ type: types_1.USERS_TYPES.update, payload: response });
        };
        var options = __assign(__assign({ dispatches: dispatches }, options_action), { dispatch_method: dispatch });
        return functions_1.updateObject(current_url_api, id, values, options);
    };
};
exports.uploadProfileImageUser = function (id, values, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var options = __assign(__assign({}, options_action), { dispatch_method: dispatch });
        return functions_1.uploadFile(current_url_api, id, 'upload_profile_image', values, options);
    };
};
