"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var forms_1 = require("../../../../ui/forms");
var Button_1 = __importDefault(require("@material-ui/core/Button"));
var redux_form_1 = require("redux-form");
var react_redux_1 = require("react-redux");
var change_password_form_validate_form_1 = __importDefault(require("./change_password_form_validate_form"));
var Typography_1 = __importDefault(require("@material-ui/core/Typography"));
var Card_1 = __importDefault(require("@material-ui/core/Card/Card"));
var CardContent_1 = __importDefault(require("@material-ui/core/CardContent"));
var ChangePasswordForm = function (props) {
    var user = props.user, pristine = props.pristine, submitting = props.submitting, reset = props.reset, handleSubmit = props.handleSubmit, classes = props.classes, is_mine = props.is_mine, changePasswordUser = props.changePasswordUser, changePasswordOtherUser = props.changePasswordOtherUser;
    var dispatch = react_redux_1.useDispatch();
    var onChangePassword = function (v) {
        if (is_mine) {
            return dispatch(changePasswordUser(user.id, v.password_old, v.password, v.password_2, { callback: reset }));
        }
        return dispatch(changePasswordOtherUser(user.id, v.password, v.password_2, { callback: reset }));
    };
    return react_1.default.createElement(Card_1.default, { className: classes.card },
        react_1.default.createElement(CardContent_1.default, null,
            react_1.default.createElement("form", { onSubmit: handleSubmit(onChangePassword) },
                react_1.default.createElement(Typography_1.default, { variant: "h5", gutterBottom: true, color: "primary" }, "Cambiar Password"),
                is_mine && react_1.default.createElement(forms_1.MyTextFieldSimple, { className: 'col-12', label: 'Contrase\u00F1a Actual', name: 'password_old', type: 'password' }),
                react_1.default.createElement(forms_1.MyTextFieldSimple, { className: 'col-12', label: 'Contrase\u00F1a Nueva', name: 'password', type: 'password' }),
                react_1.default.createElement(forms_1.MyTextFieldSimple, { className: 'col-12', label: 'Confirmar', name: 'password_2', type: 'password' }),
                react_1.default.createElement("div", { className: "col-12" },
                    react_1.default.createElement(Button_1.default, { color: "primary", variant: "contained", type: 'submit', className: 'ml-2', disabled: submitting || pristine }, "Cambiar"),
                    react_1.default.createElement(Button_1.default, { color: "primary", variant: "contained", type: 'submit', onClick: reset, className: 'ml-2', disabled: submitting || pristine }, "Limpiar")))));
};
exports.ChangePasswordForm = ChangePasswordForm;
exports.ChangePasswordForm = ChangePasswordForm = redux_form_1.reduxForm({
    form: "changePasswordForm",
    validate: change_password_form_validate_form_1.default,
    enableReinitialize: true
    // @ts-ignore
})(ChangePasswordForm);
