"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var redux_form_1 = require("redux-form");
var change_pin_form_validate_1 = __importDefault(require("./change_pin_form_validate"));
var forms_1 = require("../../../../ui/forms");
var Button_1 = __importDefault(require("@material-ui/core/Button"));
var Typography_1 = __importDefault(require("@material-ui/core/Typography"));
var Card_1 = __importDefault(require("@material-ui/core/Card"));
var CardContent_1 = __importDefault(require("@material-ui/core/CardContent"));
var react_redux_1 = require("react-redux");
var ChangePinForm = function (props) {
    var pristine = props.pristine, submitting = props.submitting, reset = props.reset, handleSubmit = props.handleSubmit, error = props.error, classes = props.classes, user = props.user, is_mine = props.is_mine, changeSecurityPinUser = props.changeSecurityPinUser, changeSecurityPinOtherUser = props.changeSecurityPinOtherUser;
    var dispatch = react_redux_1.useDispatch();
    var onChangePin = function (v) {
        if (is_mine) {
            return dispatch(changeSecurityPinUser(user.id, v.password, v.pin, { callback: reset }));
        }
        else {
            return dispatch(changeSecurityPinOtherUser(user.id, v.pin, { callback: reset }));
        }
    };
    return (react_1.default.createElement(Card_1.default, { className: classes.card },
        react_1.default.createElement(CardContent_1.default, null,
            react_1.default.createElement("form", { onSubmit: handleSubmit(onChangePin) },
                react_1.default.createElement(Typography_1.default, { variant: "h5", gutterBottom: true, color: "primary" }, "Cambiar Pin"),
                is_mine && react_1.default.createElement(forms_1.MyTextFieldSimple, { className: 'col-12', label: 'Contrase\u00F1a', name: 'password', type: 'password' }),
                react_1.default.createElement(forms_1.MyTextFieldSimple, { className: 'col-12', label: 'Nuevo Pin', name: 'pin', type: 'password' }),
                react_1.default.createElement(forms_1.MyTextFieldSimple, { className: 'col-12', label: 'Confirmar Nuevo Pin', name: 'confirmar_pin', type: 'password' }),
                react_1.default.createElement("div", { className: 'mt-3' },
                    react_1.default.createElement(Typography_1.default, { variant: "caption", gutterBottom: true, className: classes.error }, error && react_1.default.createElement("strong", null, error))),
                react_1.default.createElement("div", { className: "col-12" },
                    react_1.default.createElement(Button_1.default, { color: "primary", type: 'submit', variant: "contained", className: 'ml-3', disabled: submitting || pristine }, "Cambiar"),
                    react_1.default.createElement(Button_1.default, { color: "secondary", variant: "contained", className: 'ml-3', disabled: submitting || pristine, onClick: reset }, "Limpiar"))))));
};
exports.ChangePinForm = ChangePinForm;
exports.ChangePinForm = ChangePinForm = redux_form_1.reduxForm({
    form: "changePinForm",
    validate: change_pin_form_validate_1.default,
    enableReinitialize: true
    // @ts-ignore
})(ChangePinForm);
