"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var redux_form_1 = require("redux-form");
var forms_1 = require("../../../../ui/forms");
var actions_1 = require("../../actions");
var validate_login_form_1 = require("./validate_login_form");
var asyncValidate_1 = require("./asyncValidate");
var core_1 = require("@material-ui/core");
var LoginForm = react_1.memo(function (props) {
    var handleSubmit = props.handleSubmit, pristine = props.pristine, submitting = props.submitting, reset = props.reset, error = props.error;
    var is_loading = react_redux_1.useSelector(function (state) { return state.loading; });
    var dispatch = react_redux_1.useDispatch();
    var onSubmit = function (e) { return dispatch(actions_1.login(e.username, e.password)); };
    return react_1.default.createElement("form", { onSubmit: handleSubmit(onSubmit) },
        react_1.default.createElement(forms_1.MyTextFieldSimple, { name: 'username', label: 'Nombre de Usuario o Email', disabled: is_loading.loading, className: 'col-12', onChange: function () {
                dispatch(actions_1.clear_authentication_errors());
            } }),
        react_1.default.createElement(react_1.Fragment, null,
            react_1.default.createElement(forms_1.MyTextFieldSimple, { name: 'password', label: 'Contrase\u00F1a', className: 'col-12', type: 'password', disabled: is_loading.loading, autoFocus: true, onChange: function () {
                    dispatch(actions_1.clear_authentication_errors());
                } })),
        react_1.default.createElement("div", { className: 'mt-3' },
            react_1.default.createElement(core_1.Typography, { variant: "caption", gutterBottom: true, color: "error" }, error && react_1.default.createElement("strong", null, error))),
        react_1.default.createElement(core_1.Button, { variant: "contained", className: 'ml-3', color: 'primary', disabled: submitting || pristine || is_loading.loading, type: 'submit' }, "Ingresar"),
        react_1.default.createElement(core_1.Button, { color: "secondary", variant: "contained", className: 'ml-3', onClick: reset, disabled: submitting || pristine || is_loading.loading }, "Limpiar"));
});
exports.LoginForm = LoginForm;
exports.LoginForm = LoginForm = redux_form_1.reduxForm({
    form: "loginForm",
    // @ts-ignore
    validate: validate_login_form_1.validate,
    asyncValidate: asyncValidate_1.userAsyncValidate,
    asyncBlurFields: ['username'],
    enableReinitialize: true
    // @ts-ignore
})(LoginForm);
