"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var redux_form_1 = require("redux-form");
var forms_1 = require("../../../../ui/forms");
var dialogs_1 = require("../../../../ui/dialogs");
var UserFormBase_1 = require("../UserFormBase");
var core_1 = require("@material-ui/core");
var user_async_validate_1 = require("./user_async_validate");
var react_redux_1 = require("react-redux");
var user_form_validate_1 = require("../users/user_form_validate");
var RegistrationForm = function (props) {
    var onLoadCities = props.onLoadCities, onFetchCity = props.onFetchCity, clearCities = props.clearCities, createUser = props.createUser, pristine = props.pristine, submitting = props.submitting, reset = props.reset, onCancel = props.onCancel, handleSubmit = props.handleSubmit, modal_open = props.modal_open, singular_name = props.singular_name, children = props.children, error = props.error, fullScreen = props.fullScreen, show_alias = props.show_alias, show_first_name = props.show_first_name, show_last_name = props.show_last_name, show_date_of_birth = props.show_date_of_birth, show_gender = props.show_gender, show_city = props.show_city;
    var dispatch = react_redux_1.useDispatch();
    var onSubmit = function (v) { return dispatch(createUser(__assign(__assign({}, v), { registration: true }), { callback: function () { return onCancel(); } })); };
    return (react_1.default.createElement(dialogs_1.FormDialog, { onCancel: onCancel, onSubmit: handleSubmit(onSubmit), reset: reset, initialValues: null, submitting: submitting, modal_open: modal_open, pristine: pristine, element_type: singular_name, submit_text_boton: 'Registrar', fullScreen: fullScreen },
        react_1.default.createElement(UserFormBase_1.UserFormBase, { fullScreen: fullScreen, clearCities: clearCities, onFetchCity: onFetchCity, onLoadCities: onLoadCities, show_alias: show_alias, show_city: show_city, show_date_of_birth: show_date_of_birth, show_first_name: show_first_name, show_gender: show_gender, show_last_name: show_last_name }),
        react_1.default.createElement(forms_1.MyTextFieldSimple, { type: 'password', className: "col-12 col-md-6", label: 'Contrase\u00F1a', name: 'password' }),
        react_1.default.createElement(forms_1.MyTextFieldSimple, { type: 'password', className: "col-12 col-md-6", label: 'Comprobaci\u00F3n de contrase\u00F1a', name: 'password2' }),
        react_1.default.createElement("div", { className: 'mt-3' },
            react_1.default.createElement(core_1.Typography, { variant: "caption", gutterBottom: true, color: "error" }, error && react_1.default.createElement("strong", null, error))),
        children && children));
};
exports.RegistrationForm = RegistrationForm;
exports.RegistrationForm = RegistrationForm = redux_form_1.reduxForm({
    form: "registrationForm",
    // @ts-ignore
    validate: user_form_validate_1.user_form_validate,
    asyncValidate: user_async_validate_1.userAsyncValidate,
    asyncBlurFields: ['username'],
})(RegistrationForm);
