"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var redux_form_1 = require("redux-form");
var forms_1 = require("../../../../ui/forms");
var dialogs_1 = require("../../../../ui/dialogs");
var core_1 = require("@material-ui/core");
var restore_password_form_validate_1 = __importDefault(require("./restore_password_form_validate"));
var react_redux_1 = require("react-redux");
var RestorePasswordForm = function (props) {
    var dispatch = react_redux_1.useDispatch();
    var pristine = props.pristine, submitting = props.submitting, reset = props.reset, onCancel = props.onCancel, handleSubmit = props.handleSubmit, modal_open = props.modal_open, singular_name = props.singular_name, children = props.children, error = props.error, askRestorePasswordAccountUser = props.askRestorePasswordAccountUser;
    var onSubmit = function (v) { return dispatch(askRestorePasswordAccountUser(v.username, { callback: onCancel })); };
    return (react_1.default.createElement(dialogs_1.FormDialog, { onCancel: onCancel, onSubmit: handleSubmit(onSubmit), reset: reset, initialValues: null, submitting: submitting, modal_open: modal_open, pristine: pristine, element_type: singular_name, submit_text_boton: 'Restaurar' },
        react_1.default.createElement(forms_1.MyTextFieldSimple, { name: 'username', label: 'Nombre de Usuario o Email', className: 'col-12' }),
        react_1.default.createElement("div", { className: 'mt-3' },
            react_1.default.createElement(core_1.Typography, { variant: "caption", gutterBottom: true, color: "error" }, error && react_1.default.createElement("strong", null, error))),
        children && children,
        react_1.default.createElement("span", null, "Se enviar\u00E1 al correo registrado el link de recuperaci\u00F3n")));
};
exports.RestorePasswordForm = RestorePasswordForm;
exports.RestorePasswordForm = RestorePasswordForm = redux_form_1.reduxForm({
    form: "restorePasswordForm",
    enableReinitialize: true,
    validate: restore_password_form_validate_1.default
    // @ts-ignore
})(RestorePasswordForm);
