"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var Checkbox_1 = __importDefault(require("@material-ui/core/Checkbox"));
var dialogs_1 = require("../../../../ui/dialogs");
var icons_1 = require("../../../../ui/icons");
var lodash_1 = require("lodash");
var react_router_dom_1 = require("react-router-dom");
var react_table_1 = __importDefault(require("react-table"));
var react_redux_1 = require("react-redux");
function areEqual(prevProps, nextProps) {
    return prevProps.list === nextProps.list;
}
var UserCRUDTable = react_1.memo(function (props) {
    var data = props.list;
    var auth = react_redux_1.useSelector(function (state) { return state.auth; });
    var user = auth.user;
    var updateItem = props.updateItem, singular_name = props.singular_name, onDelete = props.onDelete, onSelectItemEdit = props.onSelectItemEdit, permissions = props.permissions, onSelectForDelete = props.onSelectForDelete, view_link = props.view_link;
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(react_table_1.default, { data: lodash_1.map(data), noDataText: "No hay elementos para mostrar tipo " + singular_name, columns: [
                {
                    Header: "Personal",
                    columns: [
                        {
                            Header: "Usuario",
                            accessor: "username",
                            maxWidth: 100,
                            minWidth: 100,
                            filterable: true,
                            filterMethod: function (filter, row) {
                                return row[filter.id].includes(filter.value.toLowerCase());
                            }
                        },
                        {
                            Header: "Nombres",
                            maxWidth: 300,
                            minWidth: 300,
                            filterable: true,
                            filterMethod: function (filter, row) {
                                return (row._original.first_name.includes(filter.value.toUpperCase()) ||
                                    row._original.last_name.includes(filter.value.toUpperCase()));
                            },
                            Cell: function (row) {
                                return (row.original.first_name + " " + row.original.last_name);
                            }
                        },
                        {
                            Header: "Correo",
                            accessor: "email",
                            filterable: true,
                            filterMethod: function (filter, row) {
                                return row[filter.id].includes(filter.value.toUpperCase());
                            }
                        },
                    ]
                },
                {
                    Header: "Opciones",
                    columns: [
                        {
                            Header: "Activo",
                            accessor: "is_active",
                            show: permissions.make_active_user,
                            maxWidth: 50,
                            Cell: function (row) { return (user.id !== row.original.id &&
                                react_1.default.createElement("div", { className: 'text-center', style: { width: '100%' } },
                                    react_1.default.createElement(Checkbox_1.default, { style: { margin: 0, padding: 0 }, color: 'primary', checked: row.value, onChange: function () { return updateItem(__assign(__assign({}, row.original), { is_active: !row.value })); } }))); }
                        },
                        {
                            Header: "Admin",
                            accessor: "is_superuser",
                            show: permissions.make_superuser_user,
                            maxWidth: 50,
                            Cell: function (row) { return (user.id !== row.original.id &&
                                react_1.default.createElement("div", { className: 'text-center', style: { width: '100%' } },
                                    react_1.default.createElement(Checkbox_1.default, { style: { margin: 0, padding: 0 }, color: 'primary', checked: row.value, onChange: function () { return updateItem(__assign(__assign({}, row.original), { is_superuser: !row.value })); } }))); }
                        },
                        {
                            Header: "Staff",
                            accessor: "is_staff",
                            show: permissions.make_staff_user,
                            maxWidth: 50,
                            Cell: function (row) { return (user.id !== row.original.id &&
                                react_1.default.createElement("div", { className: 'text-center', style: { width: '100%' } },
                                    react_1.default.createElement(Checkbox_1.default, { style: { margin: 0, padding: 0 }, color: 'primary', checked: row.value, onChange: function () { return updateItem(__assign(__assign({}, row.original), { is_staff: !row.value })); } }))); }
                        },
                        {
                            Header: "Elimi.",
                            show: permissions.delete,
                            maxWidth: 50,
                            Cell: function (row) {
                                return user.id !== row.original.id &&
                                    ((user.is_superuser && row.original.is_superuser) ||
                                        (!row.original.is_superuser))
                                    &&
                                        react_1.default.createElement(dialogs_1.DeleteDialog, { onSelectForDelete: onSelectForDelete, onDelete: function () {
                                                onDelete(row.original);
                                            }, element_name: row.original.username, element_type: singular_name });
                            }
                        },
                        {
                            Header: "Editar",
                            show: permissions.change,
                            maxWidth: 50,
                            Cell: function (row) { return react_1.default.createElement(icons_1.CustomIconTable, { icon: 'edit', onClick: function () { return onSelectItemEdit(row.original); } }); }
                        },
                        {
                            Header: "Ver",
                            show: permissions.detail,
                            maxWidth: 50,
                            Cell: function (row) { return react_1.default.createElement(react_router_dom_1.Link, { to: "" + view_link + row.original.id },
                                react_1.default.createElement(icons_1.CustomIconTable, { icon: 'eye' })); }
                        }
                    ]
                }
            ], defaultPageSize: 10, className: "-striped -highlight" })));
}, areEqual);
exports.UserCRUDTable = UserCRUDTable;
