"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("../../../../common");
var lodash_1 = require("lodash");
var user_form_validate = function (values) {
    var errors = {};
    var requiredFields = [
        'username',
        'first_name',
        'gender',
        'last_name',
        'email',
        'city',
        'password',
        'date_of_birth',
    ];
    requiredFields.map(function (field) {
        if (!values[field]) {
            errors[field] = 'Requerido';
        }
    });
    if (values.email && !common_1.REGEX_JUST_EMAIL.test(values.email)) {
        errors.email = 'Correo Electrónico Inválido';
    }
    if (values.password && values.password2) {
        if (values.password.length < 8 || values.password.length > 20) {
            errors.password = "La contrase\u00F1a debe tener entre 8 y 20 caracteres. Esta tiene " + values.password.length + " caracteres";
        }
        if (values.password !== values.password2) {
            errors.password = 'No Coinciden';
            errors.password2 = 'No Coinciden';
        }
    }
    var tamanos = {
        username: 30,
        first_name: 30,
        last_name: 40
    };
    lodash_1.mapKeys(tamanos, function (v, k) {
        if (values[k] && values[k].length > v) {
            errors[k] = "No debe tener m\u00E1s de " + v + " caracteres!";
        }
    });
    return errors;
};
exports.user_form_validate = user_form_validate;
