"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var extended_user_1 = require("../apps/extended_user");
// @ts-ignore
var authContext = react_1.createContext();
var ProvideAuth = function (_a) {
    var children = _a.children;
    var auth = useProvideAuth();
    return react_1.default.createElement(authContext.Provider, { value: auth }, children);
};
exports.ProvideAuth = ProvideAuth;
function useProvideAuth() {
    var dispatch = react_redux_1.useDispatch();
    var signin = function (username, password, option_actions) {
        if (option_actions === void 0) { option_actions = {}; }
        return dispatch(extended_user_1.login(username, password, option_actions));
    };
    var signout = function (options_action) {
        if (options_action === void 0) { options_action = {}; }
        return dispatch(extended_user_1.logout(options_action));
    };
    var auth = react_redux_1.useSelector(function (state) { return state.auth; });
    react_1.useEffect(function () {
        dispatch(extended_user_1.loadUser());
    }, []);
    return {
        auth: auth,
        signin: signin,
        signout: signout,
    };
}
var useAuth = function () {
    return react_1.useContext(authContext);
};
exports.useAuth = useAuth;
