"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_notification_system_redux_1 = __importDefault(require("react-notification-system-redux"));
var notificarAction = function (message, options) {
    if (options === void 0) { options = {
        title: 'Información de Acción',
        time: 5
    }; }
    var title = options.title, time = options.time;
    return function (dispatch) {
        var notificationOpts = {
            title: title,
            message: message,
            position: "tr",
            autoDismiss: time
        };
        // @ts-ignore
        dispatch(react_notification_system_redux_1.default.success(notificationOpts));
    };
};
exports.notificarAction = notificarAction;
var notificarErrorAction = function (error, options) {
    if (options === void 0) { options = { title: '', time: 5 }; }
    var time = options.time;
    return function (dispatch) {
        var notificationOpts = {
            // uid: 'once-please', // you can specify your own uid if required
            title: 'Error Sistema',
            message: error,
            autoDismiss: time,
            position: "tc",
        };
        // @ts-ignore
        dispatch(react_notification_system_redux_1.default.error(notificationOpts));
    };
};
exports.notificarErrorAction = notificarErrorAction;
