export declare const LOADING_TYPES: {
    loading: string;
    stop: string;
    error: string;
    reset: string;
};
export interface ILoading {
    loading: boolean;
    message?: string;
    messages?: {};
    error?: string;
    title?: string;
}
interface ILoadingActionLoading extends ILoading {
    type: typeof LOADING_TYPES.loading;
}
interface ILoadingActionStop extends ILoading {
    type: typeof LOADING_TYPES.stop;
}
interface ILoadingActionError extends ILoading {
    type: typeof LOADING_TYPES.error;
}
interface ILoadingActionReset extends ILoading {
    type: typeof LOADING_TYPES.reset;
}
export declare type ILoadingActionTypes = ILoadingActionLoading | ILoadingActionError | ILoadingActionStop | ILoadingActionReset;
export interface IMenu {
    open_menu: boolean;
    close_submenu: boolean;
    open_submenu: boolean;
    qty_open_submenu: number;
}
export declare const MENU_TYPES: {
    open: string;
    close: string;
    open_submenu: string;
    close_submenu: string;
    reset: string;
};
interface IMenuActionOpen extends IMenu {
    type: typeof MENU_TYPES.open;
}
interface IMenuActionClose extends IMenu {
    type: typeof MENU_TYPES.close;
}
interface IMenuActionSubMenuClose extends IMenu {
    type: typeof MENU_TYPES.close_submenu;
}
interface IMenuActionSubMenuOpen extends IMenu {
    type: typeof MENU_TYPES.open_submenu;
}
interface IMenuActionReset extends IMenu {
    type: typeof MENU_TYPES.reset;
}
export declare type IMenuActionTypes = IMenuActionOpen | IMenuActionClose | IMenuActionSubMenuClose | IMenuActionReset | IMenuActionSubMenuOpen;
export {};
