"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_redux_1 = require("react-redux");
var react_router_dom_1 = require("react-router-dom");
//import ErrorBoundary from './ErrorBoundary';
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var react_redux_2 = require("react-redux");
var index_1 = require("@material-ui/core/styles/index");
var Typography_1 = __importDefault(require("@material-ui/core/Typography"));
var actions_1 = require("../actions");
var _ = __importStar(require("lodash"));
var useStyles = index_1.makeStyles(function (theme) { return ({
    loadingOverloadUno: {
        position: 'relative'
    },
    loadingOverloadDos: {
        content: '',
        background: 'rgba(255, 255, 255, 0.5)',
        width: '100%',
        height: '7000px',
        opacity: '.9',
        position: 'absolute',
        zIndex: 1400
    },
    loadingOverloadTres: {
        maxHeight: '400px',
        overflow: 'scroll',
        borderRadius: '10px',
        position: 'fixed',
        textAlign: 'center',
        top: '50%',
        left: '50%',
        transform: 'translate(-50%, -50%)',
        zIndex: 1400,
        backgroundColor: theme.palette.primary.dark,
        padding: '0.5rem',
        color: 'white',
    },
    loadingOverloadTresError: {
        maxHeight: '400px',
        overflow: 'scroll',
        borderRadius: '10px',
        position: 'fixed',
        textAlign: 'center',
        top: '50%',
        left: '50%',
        transform: 'translate(-50%, -50%)',
        zIndex: 1400,
        backgroundColor: theme.palette.error.dark,
        padding: '0.5rem',
        color: 'white'
    },
    div_loading_close_boton: {
        textAlign: 'right',
        cursor: 'pointer',
    },
    loading_close_boton: {
        position: 'relative',
        left: '0px'
    }
}); });
var LoadingOverlay = function (props) {
    var classes = useStyles();
    var dispatch = react_redux_2.useDispatch();
    var loading_status = react_redux_1.useSelector(function (state) { return state.loading; });
    var isAuthenticated = react_redux_1.useSelector(function (state) { return state.auth.isAuthenticated; });
    if (!isAuthenticated) {
        return react_1.default.createElement(react_router_dom_1.Redirect, { to: "/" });
    }
    var loading = loading_status.loading, messages = loading_status.messages, error = loading_status.error, title = loading_status.title;
    var isActive = loading ? 'block' : 'none';
    var style = {
        loadingOverloadDos: {
            display: isActive
        },
        loadingOverloadTres: {
            maxWidth: '500px',
            wordBreak: 'break-all'
        }
    };
    return (react_1.default.createElement("div", { className: classes.loadingOverloadUno },
        react_1.default.createElement("div", { className: classes.loadingOverloadDos, style: style.loadingOverloadDos },
            react_1.default.createElement("div", { className: error ? classes.loadingOverloadTresError : classes.loadingOverloadTres, 
                // @ts-ignore
                style: __assign({}, style.loadingOverloadTres) },
                error && react_1.default.createElement("div", { className: classes.div_loading_close_boton },
                    react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { className: classes.loading_close_boton, icon: ['far', 'times'], size: '2x', onClick: function () { return dispatch(actions_1.resetLoading()); } })),
                error ?
                    react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: ['far', 'exclamation-circle'], size: '2x' }) :
                    react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: ['far', 'spinner-third'], size: '2x', spin: true }),
                react_1.default.createElement(Typography_1.default, { variant: "h4", color: "inherit", noWrap: true }, title),
                react_1.default.createElement(Typography_1.default, { variant: "overline", color: "inherit", gutterBottom: true }, _.size(messages) > 0 && react_1.default.createElement("div", { className: 'row' }, _.map(messages, function (m) { return react_1.default.createElement("div", { key: m, className: "col-12" }, m); }))))),
        props.children));
};
exports.LoadingOverlay = LoadingOverlay;
