"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var core_1 = require("@material-ui/core");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var useStyles = core_1.makeStyles(function (theme) { return ({
    iconoDelete: {
        color: theme.palette.primary.dark
    },
    elementNameText: {
        color: theme.palette.primary.dark,
        fontSize: '1rem'
    },
}); });
exports.DeleteDialog = function (props) {
    var _a = react_1.useState(false), is_open = _a[0], setIsOpen = _a[1];
    var classes = useStyles();
    var onDelete = props.onDelete, _b = props.onSelectForDelete, onSelectForDelete = _b === void 0 ? null : _b, element_type = props.element_type, element_name = props.element_name;
    react_1.useEffect(function () {
        if (onSelectForDelete) {
            onSelectForDelete();
        }
    }, []);
    return (react_1.default.createElement(react_1.Fragment, null,
        react_1.default.createElement("div", { className: 'text-center' },
            react_1.default.createElement(core_1.IconButton, { style: {
                    margin: 0,
                    padding: 4,
                }, onClick: function () { return setIsOpen(true); } },
                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { className: classes.iconoDelete, icon: ['far', 'trash'], size: 'xs' }))),
        react_1.default.createElement(core_1.Dialog, { open: is_open },
            react_1.default.createElement(core_1.DialogTitle, { id: "responsive-dialog-title" }, "Eliminar " + element_type),
            react_1.default.createElement(core_1.DialogContent, null,
                react_1.default.createElement(core_1.DialogContentText, null, " Desea eliminar " + element_type,
                    " ",
                    react_1.default.createElement("strong", { className: classes.elementNameText },
                        element_name,
                        "?"))),
            react_1.default.createElement(core_1.DialogActions, null,
                react_1.default.createElement(core_1.Button, { color: "secondary", variant: "contained", onClick: function () { return setIsOpen(false); } }, "Cancelar"),
                react_1.default.createElement(core_1.Button, { color: "primary", variant: "contained", onClick: function () {
                        setIsOpen(false);
                        onDelete();
                    } }, "Eliminar")))));
};
