"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var react_router_dom_1 = require("react-router-dom");
var react_redux_1 = require("react-redux");
var actions_1 = require("../../system/actions");
var actions_2 = require("../../apps/extended_user/actions");
var core_1 = require("@material-ui/core");
var drawerWidth = 240;
var useStyles = core_1.makeStyles(function (theme) {
    var _a;
    return ({
        root: {
            display: 'flex',
        },
        appBar: {
            zIndex: theme.zIndex.drawer + 1,
            transition: theme.transitions.create(['width', 'margin'], {
                easing: theme.transitions.easing.sharp,
                duration: theme.transitions.duration.leavingScreen,
            }),
        },
        appBarShift: {
            marginLeft: drawerWidth,
            width: "calc(100% - " + drawerWidth + "px)",
            transition: theme.transitions.create(['width', 'margin'], {
                easing: theme.transitions.easing.sharp,
                duration: theme.transitions.duration.enteringScreen,
            }),
        },
        menuButton: {
            marginLeft: 12,
            marginRight: 36,
        },
        hide: {
            display: 'none',
        },
        drawer: {
            width: drawerWidth,
            flexShrink: 0,
            whiteSpace: 'nowrap',
        },
        drawerOpen: {
            width: drawerWidth,
            transition: theme.transitions.create('width', {
                easing: theme.transitions.easing.sharp,
                duration: theme.transitions.duration.enteringScreen,
            }),
        },
        boton_salir: {
            position: 'absolute',
            right: 80
        },
        drawerClose: (_a = {
                transition: theme.transitions.create('width', {
                    easing: theme.transitions.easing.sharp,
                    duration: theme.transitions.duration.leavingScreen,
                }),
                overflowX: 'hidden',
                width: theme.spacing(6 + 1)
            },
            _a[theme.breakpoints.up('sm')] = {
                width: theme.spacing(7 + 1),
            },
            _a),
        toolbar: __assign({ display: 'flex', alignItems: 'center', justifyContent: 'flex-end', padding: '0 8px' }, theme.mixins.toolbar),
        content: {
            flexGrow: 1,
            padding: theme.spacing(3),
        },
        nested: {
            paddingLeft: theme.spacing(),
        },
        iconColor: {
            color: theme.palette.primary.dark
        },
        bigAvatar: {
            width: 75,
            height: 75,
            backgroundColor: 'white',
            border: "3px solid " + theme.palette.primary.main
        },
    });
});
var DrawerMenu = function (props) {
    var _a, _b, _c, _d;
    var dispatch = react_redux_1.useDispatch();
    var menu_status = react_redux_1.useSelector(function (state) { return state.menu_status; });
    var app_configuration = react_redux_1.useSelector(function (state) { return state.app_configuration; });
    var user = react_redux_1.useSelector(function (state) { return state.auth; }).user;
    var open_menu = menu_status.open_menu, qty_open_submenu = menu_status.qty_open_submenu;
    var is_open_menu = qty_open_submenu > 0 || open_menu;
    var logo_icon_style = { position: 'relative', right: 10 };
    var _e = app_configuration.general_info_configuration, icon_small = _e.icon_small, favicon_small = _e.favicon_small;
    var classes = useStyles();
    console.log('1. renderizó menu');
    var _f = props.menu_list, menu_list = _f === void 0 ? null : _f, _g = props.title, title = _g === void 0 ? 'Colocar Titulo' : _g, children = props.children;
    react_1.useEffect(function () {
        console.log('entro a use effect del menu');
        return function () {
            dispatch(actions_1.resetMenu());
        };
    }, []);
    return (react_1.default.createElement("div", { className: classes.root },
        react_1.default.createElement(core_1.CssBaseline, null),
        react_1.default.createElement(core_1.AppBar, { position: "fixed", className: classnames_1.default(classes.appBar, (_a = {},
                _a[classes.appBarShift] = is_open_menu,
                _a)) },
            react_1.default.createElement(core_1.Toolbar, { disableGutters: !is_open_menu },
                menu_list &&
                    react_1.default.createElement(core_1.IconButton, { color: "inherit", "aria-label": "Open drawer", onClick: function () { return dispatch(actions_1.openMenu()); }, className: classnames_1.default(classes.menuButton, (_b = {},
                            _b[classes.hide] = is_open_menu,
                            _b)) },
                        react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: ['far', 'bars'] })),
                react_1.default.createElement(core_1.Typography, { className: menu_list ? '' : 'pl-5', variant: "h6", color: "inherit", noWrap: true }, title),
                user && user.profile_image_url && react_1.default.createElement("div", { style: {
                        position: 'absolute',
                        bottom: -10,
                        right: 0
                    } },
                    react_1.default.createElement(core_1.Grid, { container: true, justify: "center", alignItems: "center" },
                        react_1.default.createElement(core_1.Avatar, { alt: "Remy Sharp", src: user.profile_image_url, className: classes.bigAvatar }))),
                react_1.default.createElement("div", { className: classnames_1.default(classes.boton_salir, 'text-right') },
                    react_1.default.createElement(core_1.Button, { color: "inherit", onClick: function () { return dispatch(actions_2.logout()); } }, "Salir")))),
        react_1.default.createElement(core_1.Drawer, { variant: "permanent", className: classnames_1.default(classes.drawer, (_c = {},
                _c[classes.drawerOpen] = is_open_menu,
                _c[classes.drawerClose] = !is_open_menu,
                _c)), classes: {
                paper: classnames_1.default((_d = {},
                    _d[classes.drawerOpen] = is_open_menu,
                    _d[classes.drawerClose] = !is_open_menu,
                    _d)),
            }, open: is_open_menu },
            react_1.default.createElement("div", { className: classes.toolbar }, menu_list &&
                react_1.default.createElement(core_1.IconButton, { onClick: function () { return dispatch(actions_1.closeMenu()); } }, is_open_menu ?
                    react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: ['far', 'angle-right'], className: classes.iconColor }) :
                    react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: ['far', 'angle-left'], className: classes.iconColor }))),
            react_1.default.createElement(core_1.Divider, null),
            react_1.default.createElement(core_1.List, null,
                menu_list,
                react_1.default.createElement(react_router_dom_1.Link, { to: '/' },
                    react_1.default.createElement(core_1.ListItem, null,
                        react_1.default.createElement("img", { src: favicon_small ? favicon_small : icon_small, className: classnames_1.default(logo_icon_style, "d-inline-block align-top mr-2"), alt: "" }))))),
        react_1.default.createElement("main", { className: classes.content },
            react_1.default.createElement("div", { className: classes.toolbar }),
            children)));
};
exports.DrawerMenu = DrawerMenu;
