"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_router_dom_1 = require("react-router-dom");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var core_1 = require("@material-ui/core");
var useStyles = core_1.makeStyles(function (theme) { return ({
    main: {
        paddingLeft: theme.spacing(2),
    },
    nested: {
        paddingLeft: theme.spacing(4),
    },
    iconColor: {
        color: theme.palette.primary.dark
    }
}); });
var DrawerListItem = function (props) {
    var classes = useStyles();
    var link = props.link, text = props.text, icon = props.icon, _a = props.type, type = _a === void 0 ? 'main' : _a, _b = props.size, size = _b === void 0 ? null : _b;
    console.log('3. renderizó list item menu');
    return (react_1.default.createElement(react_router_dom_1.Link, { to: link },
        react_1.default.createElement(core_1.ListItem, { button: true, className: type === 'main' ? classes.main : classes.nested },
            icon &&
                react_1.default.createElement(core_1.Tooltip, { title: text },
                    react_1.default.createElement(core_1.ListItemIcon, null,
                        react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { className: classes.iconColor, icon: ['far', icon], size: size }))),
            react_1.default.createElement(core_1.ListItemText, { inset: true, primary: text }))));
};
exports.DrawerListItem = DrawerListItem;
