"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Grid_1 = __importDefault(require("@material-ui/core/Grid"));
var styles_1 = require("@material-ui/core/styles");
var react_1 = __importStar(require("react"));
var redux_form_1 = require("redux-form");
var async_1 = __importDefault(require("react-select/async"));
var useStyles = styles_1.makeStyles(function (theme) { return ({
    error: {
        color: "" + theme.palette.error.main
    },
}); });
var renderSelectAsync = function (props) {
    var input = props.input, onLoadOptions = props.onLoadOptions, cleanMethod = props.cleanMethod, min_length = props.min_length, inicialValueLoader = props.inicialValueLoader, _a = props.meta, touched = _a.touched, error = _a.error, warning = _a.warning, label = props.label, _b = props.valueKey, valueKey = _b === void 0 ? "id" : _b, _c = props.labelKey, labelKey = _c === void 0 ? "to_string" : _c;
    var classes = useStyles();
    var _d = react_1.useState([]), inicial = _d[0], setInicial = _d[1];
    var _e = react_1.useState([]), options = _e[0], setOptions = _e[1];
    react_1.useEffect(function () {
        if (input.value && inicialValueLoader) {
            inicialValueLoader(input.value, function (response) {
                setInicial([{
                        // @ts-ignore
                        value: response[valueKey],
                        // @ts-ignore
                        label: response[labelKey]
                    }]);
            });
        }
        return function () { return cleanMethod(); };
    }, [input.value]);
    var loadOptions = function (inputValue, callback) {
        if (inputValue.length >= min_length) {
            onLoadOptions(inputValue, function (response) {
                // @ts-ignore
                var options = response.map(function (e) { return ({ value: e[valueKey], label: e[labelKey] }); });
                setOptions(options);
                callback(options);
            });
        }
    };
    return (react_1.default.createElement(react_1.Fragment, null,
        react_1.default.createElement(async_1.default, { value: __spreadArrays(options, inicial).filter(function (_a) {
                var value = _a.value;
                return value === input.value;
            }), loadOptions: loadOptions, onChange: function (value) { return input.onChange(value.value); }, placeholder: label }),
        touched && ((error && react_1.default.createElement("span", { className: classes.error }, error)) || (warning &&
            react_1.default.createElement("span", null, warning)))));
};
exports.MySelectAsync = function (props) {
    var name = props.name, _a = props.className, className = _a === void 0 ? 'col-12' : _a, onLoadOptions = props.onLoadOptions, _b = props.inicialValueLoader, inicialValueLoader = _b === void 0 ? null : _b, _c = props.valueKey, valueKey = _c === void 0 ? "id" : _c, _d = props.min_length, min_length = _d === void 0 ? 3 : _d, _e = props.labelKey, labelKey = _e === void 0 ? "to_string" : _e, label_space_xs = props.label_space_xs, label = props.label, cleanMethod = props.cleanMethod;
    return (react_1.default.createElement("div", { className: className },
        react_1.default.createElement(Grid_1.default, { component: "label", container: true, alignItems: "center", spacing: 2 },
            label_space_xs > 0 && label &&
                // @ts-ignore
                react_1.default.createElement(Grid_1.default, { item: true, xs: label_space_xs }, label),
            react_1.default.createElement(Grid_1.default, { item: true, 
                // @ts-ignore
                xs: label ? 12 - label_space_xs : 12 },
                react_1.default.createElement(redux_form_1.Field, { min_length: min_length, cleanMethod: cleanMethod, valueKey: valueKey, labelKey: labelKey, cacheOptions: true, onLoadOptions: onLoadOptions, inicialValueLoader: inicialValueLoader, name: name, component: renderSelectAsync })))));
};
